local classicAlliance = LootReserve:GetCurrentExpansion() == 0 and "Alliance" or nil;
local classicHorde = LootReserve:GetCurrentExpansion() == 0 and "Horde" or nil

--[[
ClassMask id
1  - 1    - Warrior
2  - 2    - Paladin
3  - 4    - Hunter
4  - 8    - Rogue
5  - 16   - Priest
6  - 32   - Death Knight
7  - 64   - Shaman
8  - 128  - Mage
9  - 256  - Warlock
10 - 512  - Monk
11 - 1024 - Druid
12 - 2048 - Demon Hunter
--]]

LootReserve.Data =
{
    Categories =
    {
        [-100] = {
            Children =
            {
                { Name = "My Reserves", Reserves = "my" },
                { Name = "All Reserves", Reserves = "all" },
                { Name = "|TInterface\\AddOns\\LootReserve\\Textures\\FavoriteWhite:16:16:0:-1:32:32:7:25:2:20|t Favorites", Favorites = true },
                { Name = "|TInterface\\Common\\UI-SearchBox-Icon:16:16:2:-2|t Search Results", Search = true },
            },
        },
        [-50] = {
            Name = "Custom",
            Custom = true,
            Children =
            {
                { Name = "Edited Items", Edited = true },
                { Name = "Custom Items", Custom = true },
            },
        },
        -- Classic
        [100] = {
            Name = "Molten Core",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Lucifron",
                    Loot =
                    {
                        16800, 16805, 16829, 16837, 16859, 16863, 0,
                        18870, 17109, 19145, 19146, 18872, 18875, 18861, 18879, 19147, 17077, 18878, 0,
                        16665,
                    },
                },
                {
                    Name = "Magmadar",
                    Loot =
                    {
                        16814, 16796, 16810, 16822, 16835, 16847, 16843, 16855, 16867, 0,
                        18203, 0,
                        17065, 18829, 18823, 19143, 19136, 18861, 19144, 18824, 18821, 18820, 19142, 17069, 17073, 18822,
                    },
                },
                {
                    Name = "Gehennas",
                    Loot =
                    {
                        16812, 16826, 16849, 16839, 16860, 16862, 0,
                        18870, 19145, 19146, 18872, 18875, 18861, 18879, 19147, 17077, 18878,
                    },
                },
                {
                    Name = "Garr",
                    Loot =
                    {
                        18564, 0,
                        16813, 16795, 16808, 16821, 16834, 16846, 16842, 16854, 16866, 0,
                        18829, 18823, 19143, 19136, 18861, 19144, 18824, 18821, 18820, 19142, 17066, 17071, 17105, 18832, 18822,
                    },
                },
                {
                    Name = "Shazzrah",
                    Loot =
                    {
                        16811, 16801, 16803, 16824, 16831, 16852, 0,
                        18870, 19145, 19146, 18872, 18875, 18861, 18879, 19147, 17077, 18878,
                    },
                },
                {
                    Name = "Baron Geddon",
                    Loot =
                    {
                        18563, 0,
                        16797, 16807, 16836, 16844, 16856, 0,
                        18829, 18823, 19143, 19136, 18861, 19144, 18824, 18821, 17110, 18820, 19142, 18822,
                    },
                },
                {
                    Name = "Golemagg the Incinerator",
                    Loot =
                    {
                        16815, 16798, 16809, 16820, 16833, 16845, 16841, 16853, 16865, 0,
                        17203, 0,
                        18829, 18823, 19143, 19136, 18861, 19144, 18824, 18821, 18820, 19142, 17072, 17103, 18822, 18842,
                    },
                },
                {
                    Name = "Sulfuron Harbinger",
                    Loot =
                    {
                        16816, 16823, 16848, 16868, 0,
                        18870, 19145, 19146, 18872, 18875, 18861, 18879, 19147, 17077, 18878, 17074,
                    },
                },
                {
                    Name = "Majordomo Executus",
                    Loot =
                    {
                        19139, 18810, 18811, 18808, 18809, 18812, 18806, 19140, 18805, 18803, 0,
                        18703, 18646,
                    },
                },
                {
                    Name = "Ragnaros",
                    Loot =
                    {
                        17204, 19017, 0,
                        16922, 16915, 16930, 16909, 16901, 16938, 16946, 16954, 16962, 0,
                        17082, 0,
                        18817, 18814, 17102, 17107, 19137, 17063, 19138, 18815, 17106, 18816, 17104, 17076, 0,
                        21110,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        16817, 16802, 16806, 16827, 16828, 16851, 16838, 16858, 16864, 0,
                        16819, 16799, 16804, 16825, 16830, 16850, 16840, 16857, 16861, 0,
                        17011, 17010, 11382, 17012, 0,
                        20951,
                    },
                },
                {
                    Name = "Recipes",
                    Loot =
                    {
                        18264, 0,
                        18292, 18291, 18290, 0,
                        18259, 18260, 0,
                        18252, 0,
                        18265, 21371, 0,
                        18257,
                    },
                },
            },
        },
        [200] = {
            Name = "Onyxia",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Onyxia",
                    Loot =
                    {
                        16921, 16914, 16929, 16908, 16900, 16939, 16947, 16955, 16963, 0,
                        18422, 18423, 15410, 0,
                        18705, 0,
                        18205, 17078, 18813, 17064, 17067, 17068, 17075, 0,
                        17966, 11938,
                    },
                },
            },
        },
        [300] = {
            Name = "Blackwing Lair",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Razorgore the Untamed",
                    Loot =
                    {
                        16926, 16918, 16934, 16911, 16904, 16935, 16943, 16951, 16959, 0,
                        19336, 19337, 0,
                        19370, 19369, 19335, 19334,
                    },
                },
                {
                    Name = "Vaelastrasz the Corrupt",
                    Loot =
                    {
                        16925, 16818, 16933, 16910, 16903, 16936, 16944, 16952, 16960, 0,
                        19339, 19340, 0,
                        19372, 19371, 19348, 19346,
                    },
                },
                {
                    Name = "Broodlord Lashlayer",
                    Loot =
                    {
                        16919, 16912, 16927, 16906, 16898, 16941, 16949, 16957, 16965, 0,
                        19341, 19342, 0,
                        19373, 19374, 19350, 19351, 0,
                        20383,
                    },
                },
                {
                    Name = "Firemaw",
                    Loot =
                    {
                        16920, 16913, 16928, 16907, 16899, 16940, 16948, 16956, 16964, 0,
                        19344, 19343, 0,
                        19394, 19398, 19399, 19400, 19396, 19401, 19402, 0,
                        19365, 19353, 19355, 0,
                        19397, 19395,
                    },
                },
                {
                    Name = "Ebonroc",
                    Loot =
                    {
                        16920, 16913, 16928, 16907, 16899, 16940, 16948, 16956, 16964, 0,
                        19345, 19406, 19395, 0,
                        19394, 19407, 19396, 19405, 0,
                        19368, 19353, 19355, 0,
                        19403, 19397,
                    },
                },
                {
                    Name = "Flamegor",
                    Loot =
                    {
                        16920, 16913, 16928, 16907, 16899, 16940, 16948, 16956, 16964, 0,
                        19395, 19431, 0,
                        19394, 19430, 19396, 19433, 0,
                        19367, 19353, 19357, 19355, 0,
                        19432, 19397,
                    },
                },
                {
                    Name = "Chromaggus",
                    Loot =
                    {
                        16924, 16917, 16932, 16832, 16902, 16937, 16945, 16953, 16961, 0,
                        19389, 19386, 19390, 19388, 19393, 19392, 19385, 19391, 19387, 0,
                        19361, 19349, 19347, 19352,
                    },
                },
                {
                    Name = "Nefarian",
                    Loot =
                    {
                        16923, 16916, 16931, 16905, 16897, 16942, 16950, 16958, 16966, 0,
                        19002, 19003, 0,
                        19360, 19363, 19364, 19356, 0,
                        19375, 19377, 19378, 19380, 19381, 19376, 19382, 19379, 0,
                        11938, 0,
                        21138,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        19436, 19439, 19437, 19438, 19434, 19435, 19362, 19354, 19358, 0,
                        18562,
                    },
                },
            },
        },
        [400] = {
            Name = "Zul'Gurub",
            Expansion = 0,
            Children =
            {
                {
                    Name = "High Priestess Jeklik",
                    Loot =
                    {
                        19918, 0,
                        19923, 19928, 20262, 20265, 19920, 19915, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                {
                    Name = "High Priest Venoxis",
                    Loot =
                    {
                        19904, 19903, 0,
                        19907, 19906, 19905, 19900, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                {
                    Name = "High Priestess Mar'li",
                    Loot =
                    {
                        20032, 19927, 0,
                        19871, 19919, 19925, 19930, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                {
                    Name = "Bloodlord Mandokir",
                    Loot =
                    {
                        19872, 0,
                        22637, 0,
                        20038, 19867, 19866, 19874, 0,
                        19878, 19870, 19869, 19895, 19877, 19873, 19863, 19893, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                { Name = "Edge of Madness", Header = true },
                {
                    Name = " - Gri'lek",
                    Loot =
                    {
                        19961, 19962, 0,
                        19939,
                    },
                },
                {
                    Name = " - Hazza'rah",
                    Loot =
                    {
                        19967, 19968, 0,
                        19942,
                    },
                },
                {
                    Name = " - Renataki",
                    Loot =
                    {
                        19964, 19963, 0,
                        19940,
                    },
                },
                {
                    Name = " - Wushoolay",
                    Loot =
                    {
                        19993, 19965, 0,
                        19941,
                    },
                },
                {
                    Name = "High Priest Thekal",
                    Loot =
                    {
                        19902, 0,
                        19896, 19897, 0,
                        19899, 20260, 20266, 19898, 19901, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                {
                    Name = "High Priestess Arlokk",
                    Loot =
                    {
                        19910, 19909, 0,
                        19913, 19912, 19922, 0,
                        19914, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                {
                    Name = "Jin'do the Hexxer",
                    Loot =
                    {
                        22637, 0,
                        19885, 19891, 19890, 19884, 0,
                        19886, 19875, 19888, 19929, 19894, 19889, 19887, 19892, 0,
                        19721, 19724, 19723, 19722, 19717, 19716, 19718, 19719, 19720,
                    },
                },
                {
                    Name = "Hakkar",
                    Loot =
                    {
                        19857, 20257, 20264, 19855, 19876, 19856, 0,
                        19802, 0,
                        19861, 19853, 19862, 19864, 19865, 19852, 19859, 19854,
                    },
                },
                { Separator = true },
                {
                    Name = "High Priest Shared Loot",
                    Loot =
                    {
                        22721, 22722, 0,
                        22720, 22718, 22711, 22712, 22715, 22714, 22716, 22713,
                    },
                },
                { Separator = true },
                {
                    Name = "Gahz'ranka",
                    Loot =
                    {
                        19945, 19944, 0,
                        19947, 19946, 0,
                        22739,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        20263, 20259, 20261, 19921, 19908, 20258, 0,
                        19707, 19708, 19709, 19710, 19711, 19712, 19713, 19714, 19715, 0,
                        19698, 19699, 19700, 19701, 19702, 19703, 19704, 19705, 19706,
                    },
                },
            },
        },
        [500] = {
            Name = "Ruins of Ahn'Qiraj",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Kurinnaxx",
                    Loot =
                    {
                        21499, 21498, 0,
                        21502, 21501, 21500, 21503, 0,
                        20885, 20889, 20888, 20884,
                    },
                },
                {
                    Name = "General Rajaxx",
                    Loot =
                    {
                        21493, 21492, 0,
                        21496, 21494, 21495, 21497, 21810, 21809, 21806, 0,
                        20885, 20889, 20888, 20884, 0,
                    },
                },
                {
                    Name = "Moam",
                    Loot =
                    {
                        21472, 21467, 21479, 21471, 0,
                        21455, 21468, 21474, 21470, 21469, 21476, 21475, 21477, 21473, 0,
                        20890, 20886, 0,
                        20888, 20884, 0,
                        22220,
                    },
                },
                {
                    Name = "Buru the Gorger",
                    Loot =
                    {
                        21487, 21486, 21485, 0,
                        21491, 21489, 21490, 21488, 0,
                        20890, 20886, 0,
                        20885, 20889, 20888, 20884,
                    },
                },
                {
                    Name = "Ayamiss the Hunter",
                    Loot =
                    {
                        21479, 21478, 21466, 0,
                        21484, 21480, 21482, 21481, 21483, 0,
                        20890, 20886, 0,
                        20885, 20889, 20888, 20884,
                    },
                },
                {
                    Name = "Ossirian the Unscarred",
                    Loot =
                    {
                        21460, 21454, 21453, 21456, 21464, 21457, 21462, 21458, 21463, 21461, 0,
                        21459, 21715, 21452, 0,
                        20890, 20886, 20888, 20884, 0,
                        21220,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        21804, 21803, 21805, 21801, 21800, 21802, 0,
                        20873, 20869, 20866, 20870, 20868, 20871, 20867, 20872, 0,
                        20864, 20861, 20863, 20862, 20859, 20865, 20860, 20858, 0,
                        21761, 21156, 22203, 22202,
                    },
                },
                {
                    Name = "Enchants",
                    Loot =
                    {
                        20728, 20731, 20734, 20729, 20736, 20730, 20727,
                    },
                },
                {
                    Name = "Class books",
                    Loot =
                    {
                        21284, 21287, 21285, 21279, 21214, 21280, 21281, 21283, 21282, 21300, 21303, 21302, 21294, 21296, 21295, 21306, 21304, 21307, 21291, 21292, 21293, 21288, 21289, 21290, 21298, 21299, 21297,
                    },
                },
            },
        },
        [600] = {
            Name = "Temple of Ahn'Qiraj",
            Expansion = 0,
            Children =
            {
                {
                    Name = "The Prophet Skeram",
                    Loot =
                    {
                        21699, 21814, 21708, 21698, 21705, 21704, 21706, 0,
                        21702, 21700, 21701, 21707, 21703, 21128, 0,
                        21237, 21232, 0,
                        22222,
                    },
                },
                {
                    Name = "Bug Trio",
                    Loot =
                    {
                        21693, 21694, 21697, 21696, 21692, 21695, 0,
                        21237, 21232,
                    },
                },
                {
                    Name = " - Kri Killed Last",
                    Loot =
                    {
                        21680, 21681, 21685, 21603,
                    },
                },
                {
                    Name = " - Vem Killed Last",
                    Loot =
                    {
                        21690, 21689, 21691, 21688,
                    },
                },
                {
                    Name = " - Yauj Killed Last",
                    Loot =
                    {
                        21686, 21684, 21683, 21682, 21687,
                    },
                },
                {
                    Name = "Battleguard Sartura",
                    Loot =
                    {
                        21669, 21678, 21671, 21672, 21674, 21675, 21676, 21668, 21667, 21648, 21670, 21666, 21673, 0,
                        21237, 21232,
                    },
                },
                {
                    Name = "Fankriss the Unyielding",
                    Loot =
                    {
                        21665, 21639, 21627, 21663, 21652, 21651, 21645, 21650, 21635, 0,
                        21664, 21647, 22402, 22396, 0,
                        21237, 21232,
                    },
                },
                {
                    Name = "Viscidus",
                    Loot =
                    {
                        21624, 21623, 21626, 21622, 0,
                        21677, 21625, 22399, 0,
                        21237, 21232, 0,
                        20928, 20932,
                    },
                },
                {
                    Name = "Princess Huhuran",
                    Loot =
                    {
                        21621, 21618, 21619, 21617, 21620, 21616, 0,
                        21237, 21232, 0,
                        20928, 20932,
                    },
                },
                {
                    Name = "Twin Emperors",
                    Loot =
                    {
                        21602, 21599, 21598, 21600, 21601, 21597, 21608, 21604, 21605, 21609, 21607, 21606, 21679, 0,
                        20735, 20726, 0,
                        21232, 21237, 0,
                        20930, 20926,
                    },
                },
                {
                    Name = "Ouro",
                    Loot =
                    {
                        21615, 21611, 23558, 23570, 21610, 23557, 0,
                        21237, 21232, 0,
                        20927, 20931,
                    },
                },
                {
                    Name = "C'Thun",
                    Loot =
                    {
                        22732, 21583, 22731, 22730, 21582, 21586, 21585, 21581, 21596, 21579, 21839, 21126, 21134, 0,
                        20929, 20933, 0,
                        21221,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        21838, 21888, 21889, 21856, 21837, 21836, 21891, 0,
                        21218, 21324, 21323, 21321, 0,
                        22203, 22202,
                    },
                },
                {
                    Name = "Scarabs",
                    Loot =
                    {
                        20876, 20879, 20875, 20878, 20881, 20877, 20874, 20882, 0,
                        21762, 21156, 0,
                        20864, 20861, 20863, 20862, 20859, 20865, 20860, 20858,
                    },
                },
                {
                    Name = "Enchants",
                    Loot =
                    {
                        20728, 20731, 20734, 20729, 20736, 20730, 20727,
                    },
                },
            },
        },
        [700] = {
            Name = "Naxxramas",
            Expansion = 0,
            Children =
            {
                {
                    Name = "Anub'Rekhan",
                    Loot =
                    {
                        22369, 22362, 22355, 0,
                        22935, 22938, 22936, 22939, 22937, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Grand Widow Faerlina",
                    Loot =
                    {
                        22369, 22362, 22355, 0,
                        22943, 22941, 22940, 22942, 22806, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Maexxna",
                    Loot =
                    {
                        22371, 22364, 22357, 0,
                        22947, 23220, 22954, 22807, 22804, 0,
                        22726, 22727,
                    },
                },
                { Separator = true },
                {
                    Name = "Noth the Plaguebringer",
                    Loot =
                    {
                        22370, 22363, 22356, 0,
                        23030, 23031, 23028, 23029, 23006, 23005, 22816, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Heigan the Unclean",
                    Loot =
                    {
                        22370, 22363, 22356, 0,
                        23035, 23033, 23019, 23036, 23068, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Loatheb",
                    Loot =
                    {
                        22366, 22359, 22352, 0,
                        23038, 23037, 23042, 23039, 22800, 0,
                        22726, 22727,
                    },
                },
                { Separator = true },
                {
                    Name = "Instructor Razuvious",
                    Loot =
                    {
                        22372, 22365, 22358, 0,
                        23017, 23219, 23018, 23004, 23009, 23014, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Gothik the Harvester",
                    Loot =
                    {
                        22372, 22365, 22358, 0,
                        23032, 23020, 23023, 23021, 23073, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "The Four Horsemen",
                    Loot =
                    {
                        22351, 22350, 22349, 0,
                        23071, 23025, 23027, 22811, 22809, 22691, 0,
                        22726, 22727,
                    },
                },
                { Separator = true },
                {
                    Name = "Patchwerk",
                    Loot =
                    {
                        22368, 22361, 22354, 0,
                        22960, 22961, 22820, 22818, 22815, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Grobbulus",
                    Loot =
                    {
                        22368, 22361, 22354, 0,
                        22968, 22967, 22810, 22803, 22988, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Gluth",
                    Loot =
                    {
                        22983, 22981, 22994, 23075, 22813, 0,
                        22368, 22369, 22370, 22372, 22361, 22362, 22363, 22365, 22354, 22355, 22356, 22358, 0,
                        22726, 22727,
                    },
                },
                {
                    Name = "Thaddius",
                    Loot =
                    {
                        22367, 22360, 22353, 0,
                        23000, 23070, 23001, 22808, 22801, 0,
                        22726, 22727,
                    },
                },
                { Separator = true },
                {
                    Name = "Sapphiron",
                    Loot =
                    {
                        23050, 23045, 23040, 23047, 23041, 23046, 23049, 23048, 23043, 23242, 0,
                        23549, 23548, 23545, 23547,
                    },
                },
                {
                    Name = "Kel'Thuzad",
                    Loot =
                    {
                        23057, 23053, 22812, 22821, 22819, 22802, 23056, 23054, 23577, 22798, 22799, 0,
                        22520, 0,
                        23061, 23062, 23063, 23060, 23064, 23067, 23065, 23066, 23059,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        23664, 23667, 23069, 23226, 23663, 23666, 23665, 23668, 23237, 23238, 23044, 23221, 0,
                        22376, 22373, 22374, 22375, 0,
                        23055, 22682,
                    },
                },
            },
        },
        -- The Burning Crusade
        [1000] = {
            Name = "Karazhan",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Attumen the Huntsman",
                    Loot =
                    {
                        28477, 28507, 28508, 28453, 28506, 28503, 28454, 28502, 28505, 0,
                        28509, 28510, 28504, 0,
                        30480, 0,
                        23809,
                    },
                },
                { Name = "Servant Quarters", Header = true },
                {
                    Name = " - Rokad the Ravager",
                    Loot =
                    {
                        30684, 30685, 30686, 30687,
                    },
                },
                {
                    Name = " - Shadikith the Glider",
                    Loot =
                    {
                        30680, 30681, 30682, 30683,
                    },
                },
                {
                    Name = " - Hyakiss the Lurker",
                    Loot =
                    {
                        30675, 30676, 30677, 30678,
                    },
                },
                { Separator = true },
                {
                    Name = "Moroes",
                    Loot =
                    {
                        28529, 28570, 28565, 28545, 28567, 28566, 28569, 0,
                        28530, 28528, 28525, 28568, 28524, 0,
                        22559,
                    },
                },
                {
                    Name = "Maiden of Virtue",
                    Loot =
                    {
                        28511, 28515, 28517, 28514, 28521, 28520, 28519, 28512, 28518, 0,
                        28516, 28523, 28522,
                    },
                },
                {
                    Name = "Opera Event",
                    Loot =
                    {
                        28594, 28591, 28589, 28593, 28590, 28592,
                    },
                },
                {
                    Name = " - The Wizard of Oz",
                    Loot =
                    {
                        28586, 28585, 28587, 28588,
                    },
                },
                {
                    Name = " - The Big Bad Wolf",
                    Loot =
                    {
                        28582, 28583, 28584, 28581,
                    },
                },
                {
                    Name = " - Romulo and Julianne",
                    Loot =
                    {
                        28578, 28579, 28572, 28573,
                    },
                },
                { Separator = true },
                {
                    Name = "Nightbane",
                    Loot =
                    {
                        28602, 28600, 28601, 28599, 28610, 28597, 28608, 0,
                        28609, 28603, 28604, 28611, 28606,
                    },
                },
                {
                    Name = "The Curator",
                    Loot =
                    {
                        28612, 28647, 28631, 28621, 28649, 28633, 0,
                        29757, 29758, 29756,
                    },
                },
                {
                    Name = "Terestian Illhoof",
                    Loot =
                    {
                        28660, 28653, 28652, 28654, 28655, 28656, 28662, 0,
                        28661, 28785, 28657, 28658, 28659, 0,
                        22561,
                    },
                },
                {
                    Name = "Shade of Aran",
                    Loot =
                    {
                        28672, 28726, 28670, 28663, 28669, 28671, 28666, 0,
                        28674, 28675, 28727, 28728, 28673, 0,
                        22560,
                    },
                },
                {
                    Name = "Netherspite",
                    Loot =
                    {
                        28744, 28742, 28732, 28741, 28735, 28740, 28743, 28733, 0,
                        28731, 28730, 28734, 28729,
                    },
                },
                { Separator = true },
                {
                    Name = "Chess Event",
                    Loot =
                    {
                        28756, 28755, 28750, 28752, 28751, 28746, 28748, 28747, 0,
                        28745, 28753, 28749, 28754,
                    },
                },
                {
                    Name = "Prince Malchezaar",
                    Loot =
                    {
                        28765, 28766, 28764, 28762, 28763, 28757, 0,
                        28770, 28768, 28767, 28773, 28771, 28772, 0,
                        29760, 29761, 29759,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        30642, 30668, 30673, 30644, 30674, 30643, 30641, 30666, 30667, 0,
                        21903, 21904, 22545, 0,
                        23857, 23864, 23862, 23865, 0,
                        21882,
                    },
                },
            },
        },
        [1010] = {
            Name = "Gruul's Lair",
            Expansion = 1,
            Children =
            {
                {
                    Name = "High King Maulgar",
                    Loot =
                    {
                        28797, 28799, 28796, 28801, 28795, 28800, 0,
                        29763, 29764, 29762,
                    },
                },
                {
                    Name = "Gruul the Dragonkiller",
                    Loot =
                    {
                        28804, 28803, 28828, 28827, 28810, 28824, 28822, 28823, 28830, 0,
                        29766, 29767, 29765, 0,
                        28802, 28794, 28825, 28826,
                    },
                },
            },
        },
        [1020] = {
            Name = "Magtheridon's Lair",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Magtheridon",
                    Loot =
                    {
                        28777, 28780, 28776, 28778, 28775, 28779, 28789, 28781, 0,
                        28774, 28782, 29458, 28783, 0,
                        29754, 29753, 29755, 0,
                        32385, 0,
                        34845, 0,
                        34846,
                    },
                },
            },
        },
        [1030] = {
            Name = "Serpentshrine Cavern",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Hydross the Unstable",
                    Loot =
                    {
                        30056, 32516, 30050, 30055, 30047, 30054, 30048, 30053, 0,
                        30052, 33055, 30664, 30629, 30049, 30051,
                    },
                },
                {
                    Name = "The Lurker Below",
                    Loot =
                    {
                        30064, 30067, 30062, 30060, 30066, 30065, 30057, 0,
                        30059, 30061, 33054, 30665, 30063, 30058,
                    },
                },
                {
                    Name = "Leotheras the Blind",
                    Loot =
                    {
                        30092, 30097, 30091, 30096, 30627, 30095, 0,
                        30239, 30240, 30241,
                    },
                },
                {
                    Name = "Fathom-Lord Karathress",
                    Loot =
                    {
                        30100, 30101, 30099, 30663, 30626, 30090, 0,
                        30245, 30246, 30247,
                    },
                },
                {
                    Name = "Morogrim Tidewalker",
                    Loot =
                    {
                        30098, 30079, 30075, 30085, 30068, 30084, 30081, 0,
                        30008, 30083, 33058, 30720, 30082, 30080,
                    },
                },
                {
                    Name = "Lady Vashj",
                    Loot =
                    {
                        30107, 30111, 30106, 30104, 30102, 30112, 30109, 30110, 30621, 30103, 30108, 30105, 0,
                        30242, 30243, 30244,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        30027, 30022, 30620, 30023, 30021, 30025, 0,
                        30324, 30322, 30323, 30321, 30280, 30282, 30283, 30281, 30308, 30304, 30305, 30307, 30306, 30301, 30303, 30302, 0,
                        30183, 0,
                        32897,
                    },
                },
            },
        },
        [1040] = {
            Name = "The Eye",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Al'ar",
                    Loot =
                    {
                        29925, 29918, 29947, 29921, 29922, 29920, 30448, 30447, 29923, 0,
                        32944, 29948, 29924, 29949,
                    },
                },
                {
                    Name = "Void Reaver",
                    Loot =
                    {
                        29986, 29984, 29985, 29983, 32515, 30619, 30450, 0,
                        30248, 30249, 30250,
                    },
                },
                {
                    Name = "High Astromancer Solarian",
                    Loot =
                    {
                        29977, 29972, 29966, 29976, 29951, 29965, 29950, 32267, 0,
                        30446, 30449, 29962, 29981, 29982,
                    },
                },
                {
                    Name = "Kael'thas Sunstrider",
                    Loot =
                    {
                        29992, 29989, 29994, 29990, 29987, 29995, 29991, 29998, 29997, 29993, 29996, 29988, 0,
                        30236, 30237, 30238, 0,
                        32405, 0,
                        32458,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        30024, 30020, 30029, 30026, 30030, 30028, 0,
                        30324, 30322, 30323, 30321, 30280, 30282, 30283, 30281, 30308, 30304, 30305, 30307, 30306, 30301, 30303, 30302, 0,
                        30183, 0,
                        32897,
                    }
                },
            },
        },
        [1050] = {
            Name = "Battle for Mount Hyjal",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Rage Winterchill",
                    Loot =
                    {
                        30871, 30870, 30863, 30868, 30864, 30869, 30873, 30866, 30862, 30861, 0,
                        30865, 30872,
                    },
                },
                {
                    Name = "Anetheron",
                    Loot =
                    {
                        30884, 30888, 30885, 30879, 30886, 30887, 30880, 30878, 0,
                        30874, 30881, 30883, 30882,
                    },
                },
                { Separator = true },
                {
                    Name = "Kaz'rogal",
                    Loot =
                    {
                        30895, 30916, 30894, 30917, 30914, 30891, 30892, 30919, 30893, 30915, 0,
                        30918, 30889,
                    },
                },
                {
                    Name = "Azgalor",
                    Loot =
                    {
                        30899, 30898, 30900, 30896, 30897, 0,
                        30901, 0,
                        31092, 31094, 31093,
                    },
                },
                { Separator = true },
                {
                    Name = "Archimonde",
                    Loot =
                    {
                        30913, 30912, 30905, 30907, 30904, 30903, 30911, 0,
                        30910, 30902, 30908, 30909, 30906, 0,
                        31097, 31095, 31096,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        32590, 34010, 32609, 32592, 32591, 32589, 0,
                        34009, 32946, 32945, 0,
                        32285, 32296, 32303, 32295, 32298, 32297, 32289, 32307, 0,
                        32428, 32897,
                    },
                },
            },
        },
        [1060] = {
            Name = "Black Temple",
            Expansion = 1,
            Children =
            {
                {
                    Name = "High Warlord Naj'entus",
                    Loot =
                    {
                        32239, 32240, 32377, 32241, 32234, 32242, 32232, 32243, 32245, 0,
                        32238, 32247, 32237, 32236, 32248,
                    },
                },
                {
                    Name = "Supremus",
                    Loot =
                    {
                        32256, 32252, 32259, 32251, 32258, 32250, 0,
                        32260, 32261, 32257, 32254, 32262, 32255, 32253,
                    },
                },
                {
                    Name = "Shade of Akama",
                    Loot =
                    {
                        32273, 32270, 32513, 32265, 32271, 32264, 32275, 32276, 32279, 32278, 32263, 32268, 0,
                        32266, 32361,
                    },
                },
                {
                    Name = "Teron Gorefiend",
                    Loot =
                    {
                        32323, 32329, 32327, 32324, 32328, 32510, 32280, 32512, 0,
                        32330, 32348, 32326, 32325,
                    },
                },
                {
                    Name = "Gurtogg Bloodboil",
                    Loot =
                    {
                        32337, 32338, 32340, 32339, 32334, 32342, 32333, 32341, 0,
                        32335, 32501, 32269, 32344, 32343,
                    },
                },
                {
                    Name = "Reliquary of the Lost",
                    Loot =
                    {
                        32353, 32351, 32347, 32352, 32517, 32346, 32354, 32345, 0,
                        32349, 32362, 32350, 32332, 32363,
                    },
                },
                {
                    Name = "Mother Shahraz",
                    Loot =
                    {
                        32367, 32366, 32365, 32370, 32368, 32369, 0,
                        31101, 31103, 31102,
                    },
                },
                {
                    Name = "The Illidari Council",
                    Loot =
                    {
                        32331, 32519, 32518, 32376, 32373, 32505, 0,
                        31098, 31100, 31099,
                    },
                },
                {
                    Name = "Illidan Stormrage",
                    Loot =
                    {
                        32524, 32525, 32235, 32521, 32497, 32483, 32496, 0,
                        32471, 32500, 32374, 32375, 32336, 0,
                        31089, 31091, 31090, 0,
                        32837, 32838,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        32590, 34012, 32609, 32593, 32592, 32608, 32606, 32591, 32589, 32526, 32528, 32527, 0,
                        34009, 32943, 34011, 0,
                        32228, 32231, 32229, 32249, 32230, 32227, 0,
                        32428, 32897,
                    },
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        32738, 32739, 32736, 32737, 32748, 32744, 32750, 32751, 32749, 32745, 32746, 32747, 32754, 32755, 32753, 32752,
                    },
                },
            },
        },
        [1070] = {
            Name = "Zul'Aman",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Akil'zon",
                    Loot =
                    {
                        33286, 33215, 33216, 33281, 33293, 33214, 33283, 0,
                        33307,
                    },
                },
                {
                    Name = "Nalorakk",
                    Loot =
                    {
                        33203, 33285, 33211, 33206, 33327, 33191, 33640, 0,
                        33307,
                    },
                },
                {
                    Name = "Jan'alai",
                    Loot =
                    {
                        33357, 33356, 33329, 33328, 33354, 33326, 33332, 0,
                        33307,
                    },
                },
                {
                    Name = "Halazzi",
                    Loot =
                    {
                        33317, 33300, 33322, 33533, 33299, 33303, 33297, 0,
                        33307,
                    },
                },
                {
                    Name = "Hex Lord Malacrass",
                    Loot =
                    {
                        33592, 33453, 33463, 33432, 33464, 33421, 33446, 0,
                        33829, 34029, 33828, 33389, 33298, 33388, 33465, 0,
                        33307,
                    },
                },
                {
                    Name = "Zul'jin",
                    Loot =
                    {
                        33471, 33479, 33469, 33473, 33466, 33830, 33831, 0,
                        33467, 33478, 33476, 33468, 33474, 0,
                        33307, 0,
                        33102,
                    },
                },
                { Separator = true },
                { Name = "Timed Chests", Header = true },
                {
                    Name = " - First Prisoner Saved",
                    Loot =
                    {
                        33590, 33591, 33489, 33480, 33483, 33971, 33805, 33481,
                    },
                },
                {
                    Name = " - Second Prisoner Saved",
                    Loot =
                    {
                        33495, 33493, 33492, 33490, 33494, 33491,
                    },
                },
                {
                    Name = " - Third Prisoner Saved",
                    Loot =
                    {
                        33497, 33500, 33496, 33499, 33498,
                    },
                },
                {
                    Name = " - Fourth Prisoner Saved",
                    Loot =
                    {
                        33809,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        33993, 0,
                        33865, 33930, 33932, 33931, 33933,
                    },
                },
            },
        },
        [1080] = {
            Name = "Sunwell Plateau",
            Expansion = 1,
            Children =
            {
                {
                    Name = "Kalecgos",
                    Loot =
                    {
                        34170, 34386, 34169, 34384, 34168, 34167, 34382, 34166, 34165, 34164, 0,
                        34848, 34851, 34852,
                    },
                },
                {
                    Name = "Brutallus",
                    Loot =
                    {
                        34181, 34180, 34381, 34178, 34177, 34179, 34176, 0,
                        34853, 34854, 34855,
                    },
                },
                {
                    Name = "Felmyst",
                    Loot =
                    {
                        34352, 34188, 34385, 34186, 34383, 34184, 34185, 34182, 0,
                        34856, 34857, 34858,
                    },
                },
                {
                    Name = "Eredar Twins",
                    Loot =
                    {
                        34205, 34190, 34210, 34202, 34393, 34209, 34391, 34195, 34392, 34194, 34208, 34390, 34192, 34388, 0,
                        34193, 34389, 35290, 35291, 35292, 34204, 34189, 34206, 34197, 34199, 34203, 34198, 34196,
                    },
                },
                {
                    Name = "M'uru",
                    Loot =
                    {
                        34232, 34233, 34399, 34212, 34398, 34211, 34397, 34234, 34408, 34229, 34396, 34228, 34215, 34394, 34240, 34216, 34395, 34213, 34230, 35282, 35283, 35284, 34427, 34430, 34429, 34428, 34214, 34231,
                    },
                },
                {
                    Name = "Kil'jaeden",
                    Loot =
                    {
                        34241, 34242, 34339, 34405, 34340, 34342, 34406, 34344, 34244, 34404, 34245, 34403, 34333, 34332, 34402, 34343, 34243, 34401, 34345, 34400, 34341, 0,
                        34329, 34247, 34335, 34331, 34336, 34337, 0,
                        34334,
                    },
                },
                { Separator = true },
                {
                    Name = "Trash",
                    Loot =
                    {
                        34351, 34407, 34350, 34409, 35733, 34183, 34346, 34349, 34348, 34347, 0,
                        35208, 35210, 35209, 35211, 0,
                        35273, 0,
                        32228, 32231, 32229, 32249, 32230, 32227, 0,
                        34664,
                    },
                },
                {
                    Name = "Patterns",
                    Loot =
                    {
                        35212, 35216, 35213, 35217, 35214, 35218, 35215, 35219, 35204, 35206, 35205, 35207, 35198, 35201, 35199, 35202, 35200, 35203, 35186, 35187, 35189, 35190, 35191, 35192, 35193, 35194, 35195, 35196, 35197,
                    },
                },
            },
        },
    },
    ItemConditions =
    {
        -- Molten Core trash
        [11382] = { Hidden = true },
        [17010] = { Hidden = true },
        [17011] = { Hidden = true },
        [17012] = { Hidden = true },

        -- Thunderfury items
        [18563] = { ClassMask = 15, Hidden = true },
        [18564] = { ClassMask = 15, Hidden = true },
        [17203] = { Hidden = true },
        [18562] = { Hidden = true },

        -- Hand of Rag items
        [17204] = { ClassMask = 1091, Hidden = true },
        [19017] = { ClassMask = 1091, Hidden = true },

        -- Scale of Onyxia
        [15410] = { Hidden = true },

        -- Head of Onyxia
        [18422] = { Faction = "Horde" },
        [18423] = { Faction = "Alliance" },

        -- Head of Nefarian
        [19002] = { Faction = "Horde" },
        [19003] = { Faction = "Alliance" },

        -- Red Scepter Shard
        [21138] = { Hidden = true },

        -- Sack of Gems
        [11938] = { Hidden = true },

        -- ZG Coins
        [19698] = { Hidden = true },
        [19699] = { Hidden = true },
        [19700] = { Hidden = true },
        [19701] = { Hidden = true },
        [19702] = { Hidden = true },
        [19703] = { Hidden = true },
        [19704] = { Hidden = true },
        [19705] = { Hidden = true },
        [19706] = { Hidden = true },

        -- ZG Bijous
        [19707] = { Hidden = true },
        [19708] = { Hidden = true },
        [19709] = { Hidden = true },
        [19710] = { Hidden = true },
        [19711] = { Hidden = true },
        [19712] = { Hidden = true },
        [19713] = { Hidden = true },
        [19714] = { Hidden = true },
        [19715] = { Hidden = true },

        --AQ20 idols
        [20866] = { ClassMask = 140, Hidden = true },
        [20867] = { ClassMask = 265, Hidden = true },
        [20868] = { ClassMask = 21, Hidden = true },
        [20869] = { ClassMask = 326, Hidden = true },
        [20870] = { ClassMask = 1296, Hidden = true },
        [20871] = { ClassMask = 210, Hidden = true },
        [20872] = { ClassMask = 1098, Hidden = true },
        [20873] = { ClassMask = 1153, Hidden = true },

        -- AQ40 idols
        [20874] = { ClassMask = 141, Hidden = true },
        [20875] = { ClassMask = 393, Hidden = true },
        [20876] = { ClassMask = 401, Hidden = true },
        [20877] = { ClassMask = 466, Hidden = true },
        [20878] = { ClassMask = 1362, Hidden = true },
        [20879] = { ClassMask = 1110, Hidden = true },
        [20881] = { ClassMask = 1102, Hidden = true },
        [20882] = { ClassMask = 1037, Hidden = true },

        -- AQ scarabs
        [20858] = { Hidden = true },
        [20859] = { Hidden = true },
        [20860] = { Hidden = true },
        [20861] = { Hidden = true },
        [20862] = { Hidden = true },
        [20863] = { Hidden = true },
        [20864] = { Hidden = true },
        [20865] = { Hidden = true },

        -- AQ scarab coffer items
        [21156] = { Hidden = true },
        [21761] = { Hidden = true },
        [21762] = { Hidden = true },

        -- AQ trash
        [22202] = { Hidden = true },
        [22203] = { Hidden = true },

        -- Naxxramas scraps
        [22376] = { Hidden = true },
        [22373] = { Hidden = true },
        [22374] = { Hidden = true },
        [22375] = { Hidden = true },

        -- Naxxramas runes
        [23055] = { Hidden = true },
        [22682] = { Hidden = true },

        -- Atiesh legendary items
        [22726] = { ClassMask = 1424, Hidden = true },
        [22727] = { ClassMask = 1424, Hidden = true },

        -- Karazhan trash
        [23857] = { Hidden = true },
        [23864] = { Hidden = true },
        [23862] = { Hidden = true },
        [23865] = { Hidden = true },
        [21882] = { Hidden = true },

        -- Magtheridon's gem bag
        [34846] = { Hidden = true },

        -- Trade items
        [32897] = { Hidden = true },
        [32428] = { Hidden = true },
        [34664] = { Hidden = true },

        -- Warglaives of Azzinoth
        [32837] = { ClassMask = 9, Hidden = true },
        [32838] = { ClassMask = 9, Hidden = true },

        -- Trash gems
        [32228] = { Hidden = true },
        [32231] = { Hidden = true },
        [32229] = { Hidden = true },
        [32249] = { Hidden = true },
        [32230] = { Hidden = true },
        [32227] = { Hidden = true },

        -- Zul'Aman trash
        [33865] = { Hidden = true },
        [33930] = { Hidden = true },
        [33932] = { Hidden = true },
        [33931] = { Hidden = true },
        [33933] = { Hidden = true },

        -- Thoridal
        [34334] = { ClassMask = 13, Hidden = true },

        -- Class restrictions on items
        [16665] = { ClassMask = 4 },
        [16795] = { ClassMask = 128 },
        [16796] = { ClassMask = 128 },
        [16797] = { ClassMask = 128 },
        [16798] = { ClassMask = 128 },
        [16799] = { ClassMask = 128 },
        [16800] = { ClassMask = 128 },
        [16801] = { ClassMask = 128 },
        [16802] = { ClassMask = 128 },
        [16803] = { ClassMask = 256 },
        [16804] = { ClassMask = 256 },
        [16805] = { ClassMask = 256 },
        [16806] = { ClassMask = 256 },
        [16807] = { ClassMask = 256 },
        [16808] = { ClassMask = 256 },
        [16809] = { ClassMask = 256 },
        [16810] = { ClassMask = 256 },
        [16811] = { ClassMask = 16 },
        [16812] = { ClassMask = 16 },
        [16813] = { ClassMask = 16 },
        [16814] = { ClassMask = 16 },
        [16815] = { ClassMask = 16 },
        [16816] = { ClassMask = 16 },
        [16817] = { ClassMask = 16 },
        [16818] = { ClassMask = 128 },
        [16819] = { ClassMask = 16 },
        [16820] = { ClassMask = 8 },
        [16821] = { ClassMask = 8 },
        [16822] = { ClassMask = 8 },
        [16823] = { ClassMask = 8 },
        [16824] = { ClassMask = 8 },
        [16825] = { ClassMask = 8 },
        [16826] = { ClassMask = 8 },
        [16827] = { ClassMask = 8 },
        [16828] = { ClassMask = 1024 },
        [16829] = { ClassMask = 1024 },
        [16830] = { ClassMask = 1024 },
        [16831] = { ClassMask = 1024 },
        [16832] = { ClassMask = 8 },
        [16833] = { ClassMask = 1024 },
        [16834] = { ClassMask = 1024 },
        [16835] = { ClassMask = 1024 },
        [16836] = { ClassMask = 1024 },
        [16837] = { ClassMask = 64, Faction = classicHorde },
        [16838] = { ClassMask = 64, Faction = classicHorde },
        [16839] = { ClassMask = 64, Faction = classicHorde },
        [16840] = { ClassMask = 64, Faction = classicHorde },
        [16841] = { ClassMask = 64, Faction = classicHorde },
        [16842] = { ClassMask = 64, Faction = classicHorde },
        [16843] = { ClassMask = 64, Faction = classicHorde },
        [16844] = { ClassMask = 64, Faction = classicHorde },
        [16845] = { ClassMask = 4 },
        [16846] = { ClassMask = 4 },
        [16847] = { ClassMask = 4 },
        [16848] = { ClassMask = 4 },
        [16849] = { ClassMask = 4 },
        [16850] = { ClassMask = 4 },
        [16851] = { ClassMask = 4 },
        [16852] = { ClassMask = 4 },
        [16853] = { ClassMask = 2, Faction = classicAlliance },
        [16854] = { ClassMask = 2, Faction = classicAlliance },
        [16855] = { ClassMask = 2, Faction = classicAlliance },
        [16856] = { ClassMask = 2, Faction = classicAlliance },
        [16857] = { ClassMask = 2, Faction = classicAlliance },
        [16858] = { ClassMask = 2, Faction = classicAlliance },
        [16859] = { ClassMask = 2, Faction = classicAlliance },
        [16860] = { ClassMask = 2, Faction = classicAlliance },
        [16861] = { ClassMask = 1 },
        [16862] = { ClassMask = 1 },
        [16863] = { ClassMask = 1 },
        [16864] = { ClassMask = 1 },
        [16865] = { ClassMask = 1 },
        [16866] = { ClassMask = 1 },
        [16867] = { ClassMask = 1 },
        [16868] = { ClassMask = 1 },
        [16897] = { ClassMask = 1024 },
        [16898] = { ClassMask = 1024 },
        [16899] = { ClassMask = 1024 },
        [16900] = { ClassMask = 1024 },
        [16901] = { ClassMask = 1024 },
        [16902] = { ClassMask = 1024 },
        [16903] = { ClassMask = 1024 },
        [16904] = { ClassMask = 1024 },
        [16905] = { ClassMask = 8 },
        [16906] = { ClassMask = 8 },
        [16907] = { ClassMask = 8 },
        [16908] = { ClassMask = 8 },
        [16909] = { ClassMask = 8 },
        [16910] = { ClassMask = 8 },
        [16911] = { ClassMask = 8 },
        [16912] = { ClassMask = 128 },
        [16913] = { ClassMask = 128 },
        [16914] = { ClassMask = 128 },
        [16915] = { ClassMask = 128 },
        [16916] = { ClassMask = 128 },
        [16917] = { ClassMask = 128 },
        [16918] = { ClassMask = 128 },
        [16919] = { ClassMask = 16 },
        [16920] = { ClassMask = 16 },
        [16921] = { ClassMask = 16 },
        [16922] = { ClassMask = 16 },
        [16923] = { ClassMask = 16 },
        [16924] = { ClassMask = 16 },
        [16925] = { ClassMask = 16 },
        [16926] = { ClassMask = 16 },
        [16927] = { ClassMask = 256 },
        [16928] = { ClassMask = 256 },
        [16929] = { ClassMask = 256 },
        [16930] = { ClassMask = 256 },
        [16931] = { ClassMask = 256 },
        [16932] = { ClassMask = 256 },
        [16933] = { ClassMask = 256 },
        [16934] = { ClassMask = 256 },
        [16935] = { ClassMask = 4 },
        [16936] = { ClassMask = 4 },
        [16937] = { ClassMask = 4 },
        [16938] = { ClassMask = 4 },
        [16939] = { ClassMask = 4 },
        [16940] = { ClassMask = 4 },
        [16941] = { ClassMask = 4 },
        [16942] = { ClassMask = 4 },
        [16943] = { ClassMask = 64, Faction = classicHorde },
        [16944] = { ClassMask = 64, Faction = classicHorde },
        [16945] = { ClassMask = 64, Faction = classicHorde },
        [16946] = { ClassMask = 64, Faction = classicHorde },
        [16947] = { ClassMask = 64, Faction = classicHorde },
        [16948] = { ClassMask = 64, Faction = classicHorde },
        [16949] = { ClassMask = 64, Faction = classicHorde },
        [16950] = { ClassMask = 64, Faction = classicHorde },
        [16951] = { ClassMask = 2, Faction = classicAlliance },
        [16952] = { ClassMask = 2, Faction = classicAlliance },
        [16953] = { ClassMask = 2, Faction = classicAlliance },
        [16954] = { ClassMask = 2, Faction = classicAlliance },
        [16955] = { ClassMask = 2, Faction = classicAlliance },
        [16956] = { ClassMask = 2, Faction = classicAlliance },
        [16957] = { ClassMask = 2, Faction = classicAlliance },
        [16958] = { ClassMask = 2, Faction = classicAlliance },
        [16959] = { ClassMask = 1 },
        [16960] = { ClassMask = 1 },
        [16961] = { ClassMask = 1 },
        [16962] = { ClassMask = 1 },
        [16963] = { ClassMask = 1 },
        [16964] = { ClassMask = 1 },
        [16965] = { ClassMask = 1 },
        [16966] = { ClassMask = 1 },
        [18646] = { ClassMask = 16 },
        [18703] = { ClassMask = 4 },
        [18705] = { ClassMask = 4 },
        [19336] = { ClassMask = 4 },
        [19337] = { ClassMask = 256 },
        [19339] = { ClassMask = 128 },
        [19340] = { ClassMask = 1024 },
        [19341] = { ClassMask = 1 },
        [19342] = { ClassMask = 8 },
        [19343] = { ClassMask = 2, Faction = classicAlliance },
        [19344] = { ClassMask = 64, Faction = classicHorde },
        [19345] = { ClassMask = 16 },
        [19716] = { ClassMask = 134 },
        [19717] = { ClassMask = 73 },
        [19718] = { ClassMask = 1296 },
        [19719] = { ClassMask = 73 },
        [19720] = { ClassMask = 1296 },
        [19721] = { ClassMask = 134 },
        [19722] = { ClassMask = 1090 },
        [19723] = { ClassMask = 385 },
        [19724] = { ClassMask = 28 },
        [20264] = { Faction = classicAlliance },
        [20257] = { Faction = classicHorde },
        [20884] = { ClassMask = 1219 },
        [20885] = { ClassMask = 153 },
        [20886] = { ClassMask = 79 },
        [20888] = { ClassMask = 284 },
        [20889] = { ClassMask = 1350 },
        [20890] = { ClassMask = 1424 },
        [20926] = { ClassMask = 401 },
        [20927] = { ClassMask = 153 },
        [20928] = { ClassMask = 29 },
        [20929] = { ClassMask = 79 },
        [20930] = { ClassMask = 1102 },
        [20931] = { ClassMask = 1350 },
        [20932] = { ClassMask = 1474 },
        [20933] = { ClassMask = 1424 },
        [21214] = { ClassMask = 128 },
        [21279] = { ClassMask = 128 },
        [21280] = { ClassMask = 128 },
        [21281] = { ClassMask = 256 },
        [21282] = { ClassMask = 256 },
        [21283] = { ClassMask = 256 },
        [21284] = { ClassMask = 16 },
        [21285] = { ClassMask = 16 },
        [21287] = { ClassMask = 16 },
        [21288] = { ClassMask = 2, Faction = classicAlliance },
        [21289] = { ClassMask = 2, Faction = classicAlliance },
        [21290] = { ClassMask = 2, Faction = classicAlliance },
        [21291] = { ClassMask = 64, Faction = classicHorde },
        [21292] = { ClassMask = 64, Faction = classicHorde },
        [21293] = { ClassMask = 64, Faction = classicHorde },
        [21294] = { ClassMask = 1024 },
        [21295] = { ClassMask = 1024 },
        [21296] = { ClassMask = 1024 },
        [21297] = { ClassMask = 1 },
        [21298] = { ClassMask = 1 },
        [21299] = { ClassMask = 1 },
        [21300] = { ClassMask = 8 },
        [21302] = { ClassMask = 8 },
        [21303] = { ClassMask = 8 },
        [21304] = { ClassMask = 4 },
        [21306] = { ClassMask = 4 },
        [21307] = { ClassMask = 4 },
        [21453] = { Faction = classicAlliance },
        [21454] = { Faction = classicHorde },
        [21486] = { Faction = classicAlliance },
        [21487] = { Faction = classicHorde },
        [21803] = { Faction = classicAlliance },
        [21804] = { Faction = classicHorde },
        [21889] = { ClassMask = 2, Faction = classicAlliance },
        [22349] = { ClassMask = 9 },
        [22350] = { ClassMask = 1094 },
        [22351] = { ClassMask = 400 },
        [22352] = { ClassMask = 9 },
        [22353] = { ClassMask = 9 },
        [22354] = { ClassMask = 9 },
        [22355] = { ClassMask = 9 },
        [22356] = { ClassMask = 9 },
        [22357] = { ClassMask = 9 },
        [22358] = { ClassMask = 9 },
        [22359] = { ClassMask = 1094 },
        [22360] = { ClassMask = 1094 },
        [22361] = { ClassMask = 1094 },
        [22362] = { ClassMask = 1094 },
        [22363] = { ClassMask = 1094 },
        [22364] = { ClassMask = 1094 },
        [22365] = { ClassMask = 1094 },
        [22366] = { ClassMask = 400 },
        [22367] = { ClassMask = 400 },
        [22368] = { ClassMask = 400 },
        [22369] = { ClassMask = 400 },
        [22370] = { ClassMask = 400 },
        [22371] = { ClassMask = 400 },
        [22372] = { ClassMask = 400 },
        [22739] = { ClassMask = 128 },
        [23059] = { ClassMask = 1 },
        [23060] = { ClassMask = 8 },
        [23061] = { ClassMask = 16 },
        [23062] = { ClassMask = 128 },
        [23063] = { ClassMask = 256 },
        [23064] = { ClassMask = 1024 },
        [23065] = { ClassMask = 64, Faction = classicHorde },
        [23066] = { ClassMask = 2, Faction = classicAlliance },
        [23067] = { ClassMask = 4 },
        [23069] = { ClassMask = 400 },
        [23664] = { ClassMask = 64, Faction = classicHorde },
        [23665] = { ClassMask = 64, Faction = classicHorde },
        [23666] = { ClassMask = 2, Faction = classicAlliance },
        [23667] = { ClassMask = 2, Faction = classicAlliance },
        [23668] = { ClassMask = 2, Faction = classicAlliance },
        [29753] = { ClassMask = 1041 },
        [29754] = { ClassMask = 74 },
        [29755] = { ClassMask = 388 },
        [29756] = { ClassMask = 388 },
        [29757] = { ClassMask = 74 },
        [29758] = { ClassMask = 1041 },
        [29759] = { ClassMask = 388 },
        [29760] = { ClassMask = 74 },
        [29761] = { ClassMask = 1041 },
        [29762] = { ClassMask = 388 },
        [29763] = { ClassMask = 74 },
        [29764] = { ClassMask = 1041 },
        [29765] = { ClassMask = 388 },
        [29766] = { ClassMask = 74 },
        [29767] = { ClassMask = 1041 },
        [30236] = { ClassMask = 74 },
        [30237] = { ClassMask = 1041 },
        [30238] = { ClassMask = 388 },
        [30239] = { ClassMask = 74 },
        [30240] = { ClassMask = 1041 },
        [30241] = { ClassMask = 388 },
        [30242] = { ClassMask = 74 },
        [30243] = { ClassMask = 1041 },
        [30244] = { ClassMask = 388 },
        [30245] = { ClassMask = 74 },
        [30246] = { ClassMask = 1041 },
        [30247] = { ClassMask = 388 },
        [30248] = { ClassMask = 74 },
        [30249] = { ClassMask = 1041 },
        [30250] = { ClassMask = 388 },
        [30446] = { ClassMask = 1 },
        [30447] = { ClassMask = 2 },
        [30448] = { ClassMask = 4 },
        [30449] = { ClassMask = 256 },
        [30450] = { ClassMask = 8 },
        [30663] = { ClassMask = 64 },
        [30664] = { ClassMask = 1024 },
        [30665] = { ClassMask = 16 },
        [30720] = { ClassMask = 128 },
        [31089] = { ClassMask = 274 },
        [31090] = { ClassMask = 1160 },
        [31091] = { ClassMask = 69 },
        [31092] = { ClassMask = 274 },
        [31093] = { ClassMask = 1160 },
        [31094] = { ClassMask = 69 },
        [31095] = { ClassMask = 69 },
        [31096] = { ClassMask = 1160 },
        [31097] = { ClassMask = 274 },
        [31098] = { ClassMask = 274 },
        [31099] = { ClassMask = 1160 },
        [31100] = { ClassMask = 69 },
        [31101] = { ClassMask = 274 },
        [31102] = { ClassMask = 1160 },
        [31103] = { ClassMask = 69 },
        [34848] = { ClassMask = 274 },
        [34851] = { ClassMask = 69 },
        [34852] = { ClassMask = 1160 },
        [34853] = { ClassMask = 274 },
        [34854] = { ClassMask = 69 },
        [34855] = { ClassMask = 1160 },
        [34856] = { ClassMask = 274 },
        [34857] = { ClassMask = 69 },
        [34858] = { ClassMask = 1160 },
        [35186] = { ClassMask = 400 },
        [35187] = { ClassMask = 2 },
        [35189] = { ClassMask = 16 },
        [35190] = { ClassMask = 1024 },
        [35191] = { ClassMask = 1024 },
        [35192] = { ClassMask = 64 },
        [35193] = { ClassMask = 64 },
        [35194] = { ClassMask = 68 },
        [35195] = { ClassMask = 35 },
        [35196] = { ClassMask = 35 },
        [35197] = { ClassMask = 1032 },
    },
};

function LootReserve.Data:IsItemInCategory(item, category)
    if item == 0 or category <= 0 then return false; end

    category = self.Categories[category];
    if category and category.Children and self:IsCategoryVisible(category) then
        for _, child in ipairs(category.Children) do
            if child.Loot then
                for _, lootItem in ipairs(child.Loot) do
                    if lootItem == item then
                        return true;
                    end
                end
            end
        end
    end

    return false;
end

function LootReserve.Data:GetItemCategories(item)
    local categories = { };
    for category in pairs(self.Categories) do
        if self:IsItemInCategory(item, category) then
            table.insert(categories, category);
        end
    end
    return categories;
end

function LootReserve.Data:IsCategoryVisible(category)
    return not category.Expansion or category.Expansion <= LootReserve:GetCurrentExpansion();
end

function LootReserve.Data.CategorySorter(a, b, aID, bID)
    if aID > 0 and bID > 0 and a.Expansion ~= b.Expansion then
        return a.Expansion > b.Expansion;
    end
    return aID < bID;
end
